// naumann@stce.rwth-aachen.de

#include "dco.hpp"

#include "f.hpp"

template<typename T, typename PT>
void first_derivative(T &x_v, const PT &p, const PT &w, T &dx) {
  using DCO_M=typename dco::ga1s<T>;
  using DCO_T=typename DCO_M::type;
  using DCO_TT=typename DCO_M::tape_t;
  DCO_T x_in; dco::value(x_in)=x_v; 
  DCO_M::global_tape=DCO_TT::create();
  DCO_M::global_tape->register_variable(x_in); 
  DCO_T x=x_in;
  f(x,p,w);
  x_v=dco::value(x);
  dco::derivative(x)=1; 
  DCO_M::global_tape->interpret_adjoint();
  dx=dco::derivative(x_in);
  DCO_TT::remove(DCO_M::global_tape);
}

#include "g_main.hpp"

