// naumann@stce.rwth-aachen.de

#include <limits>
#include <cmath>

#include "f.hpp"

template<typename T, typename PT>
void first_derivative(T &x, const PT &p, const PT &w, T &dx) {
  T h=(x==0) ? sqrt(std::numeric_limits<T>::epsilon())
	     : sqrt(std::numeric_limits<T>::epsilon())*fabs(x);
  T xph=x+h; f(xph,p,w); 
  T xmh=x-h; f(xmh,p,w); 
  dx=(xph-xmh)/(2*h); 
  f(x,p,w);
}

#include "g_main.hpp"
