// naumann@stce.rwth-aachen.de

#include "dco.hpp"

#include "f.hpp"

template<typename T, typename PT>
void second_derivative(T &x_v, const PT &p, const PT &w, T &dx,T &ddx) {
  using DCO_BT=typename dco::gt1s<T>::type;
  using DCO_M=typename dco::ga1s<DCO_BT>;
  using DCO_T=typename DCO_M::type;
  using DCO_TT=typename DCO_M::tape_t;
  DCO_T x_in; 
  dco::value(dco::value(x_in))=x_v; 
  DCO_M::global_tape=DCO_TT::create();
  DCO_M::global_tape->register_variable(x_in);
  DCO_T x=x_in;
  dco::derivative(dco::value(x))=1.; 
  f(x,p,w);
  x_v=dco::value(dco::value(x));
  dx=dco::derivative(dco::value(x));
  dco::value(dco::derivative(x))=1.; 
  DCO_M::global_tape->interpret_adjoint();
  ddx=dco::derivative(dco::derivative(x_in));
  DCO_TT::remove(DCO_M::global_tape);
}

#include "h_main.hpp"
