// naumann@stce.rwth-aachen.de

#include "dco.hpp"

#include "f.hpp"

template<typename T, typename PT>
void second_derivative(T &x_v, const PT &p, const PT &w, T &dx,T &ddx) {
  using DCO_BM=typename dco::ga1s<T>;
  using DCO_BT=typename DCO_BM::type;
  using DCO_BTT=typename DCO_BM::tape_t;
  using DCO_T=typename dco::gt1s<DCO_BT>::type;
  DCO_T x_in; 
  dco::value(dco::value(x_in))=x_v; 
  dco::value(dco::derivative(x_in))=1.; 
  DCO_BM::global_tape=DCO_BTT::create();
  DCO_BM::global_tape->register_variable(dco::value(x_in)); 
  DCO_BM::global_tape->register_variable(dco::derivative(x_in)); 
  DCO_T x=x_in;
  f(x,p,w);
  x_v=dco::value(dco::value(x));
  dx=dco::value(dco::derivative(x));
  dco::derivative(dco::derivative(x))=1.; 
  DCO_BM::global_tape->interpret_adjoint();
  ddx=dco::derivative(dco::value(x_in));
  DCO_BTT::remove(DCO_BM::global_tape);
}

#include "h_main.hpp"
