// naumann@stce.rwth-aachen.de

#include "dco.hpp"

#include "f.hpp"

template<typename T, typename PT>
void second_derivative(T &x_v, const PT &p, const PT &w, T &dx, T &ddx) {
  using DCO_BT=typename dco::gt1s<T>::type;
  using DCO_T=typename dco::gt1s<DCO_BT>::type;
  DCO_T x=0; 
  dco::value(dco::value(x))=x_v; 
  dco::value(dco::derivative(x))=1.; 
  dco::derivative(dco::value(x))=1.; 
  f(x,p,w); 
  x_v=dco::value(dco::value(x)); 
  dx=dco::value(dco::derivative(x));
  ddx=dco::derivative(dco::derivative(x));
}

#include "h_main.hpp"
